' Frequenzgenerator
' Mit Timer 0  wird eine Frequenz erzeugt die mittels Taste 1 und 2 variiert
' werden kann
' von 90 Hz bis 23 Khz
' Mit Timer 1soll diese Frequnz gemessen und angezeigt werden

'--------------------- Allgemeine Prozessor Konfiguration ---------------------
$baud = 9600                  'Rs232 Datenberagungsrate
$regfile "m32def.dat"         'Definiert den Atmega als Atmega 32
$crystal = 16000000           'Gibt die Quarzfrequenz an in Herz
'-----------------------------------------------------------------------------
' Variablen definieren
Dim Wert1 As Word
Dim A As Long                 'Schrittweite zum Aufwrts-Zhlen
Dim B As Word
Dim C As Word
Ddra = &B00000011             ' Port A0 als Ausgang setzen fr Led
Ddrb = &B00000000             ' Port B komplett als Eingnge setzen fr Taster
Portb = &B00000101            ' Port B.0 und B.2  PullUp aktivieren fr Taster

'-----------------------------------------------------------------------------
Config Timer0 = Timer , Prescale = 256
Config Timer1 = Timer , Prescale = 1024

'Bestimmt das Timer 0 verwendet und teilt den Takt durch 8

Enable Timer0                 'Startet Timer 0
Enable Timer1
On Timer0 Test0               'springt bei berlauf nach " Test"
On Timer1 Test1
Enable Interrupts             'Interrupt aktivieren

'------------------------------------------------------------------------------
' Konfiguration frs Display
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.6 , Db7 = Portc.7 , Rs = Portc.5 , E = Portc.4

'______________________ Starteinstellungen         ____________________________
  Timer1 = 54050

   A = 10                     ' Vorgabewert fr Schrittweite bei Aufwrts zhlen
     B = Porta.0
'______________________ Programm Anfang _______________________________________
    Do

'Hier wird ber Tasten 1 und 2 der Wert fr die Voreinstellung des Timers
' gendert
If Pinb.0 = 1 Then Waitms 20
If Pinb.0 = 1 Then Wert1 = Wert1 + A


'Waitms 20
If Pinb.2 = 0 Then Waitms 20
If Pinb.2 = 0 Then Decr Wert1


'--------------------- T E S T ------------------------------------------------
  Cls
  Locate 1 , 1
  Lcd "Frequenz="
  Locate 2 , 1
  Lcd C ;
  Locate 2 , 10
  Lcd "Hz"
   Waitms 100
      Loop
'_____________________ H a u p t p r o g r a m m - E n d e ____________________
Test0:                        'Sprungmarke zu der gesprungen wird wenn der Timer einen berlauf hat
Timer0 = Wert1                'Timer soll ab (Wert aus Wert1)  hochzhlen
Toggle Porta.0                'Port A.0 bei jeden berlauf umschalten
 B = B + 1
 Return
'----------------------------------------------------------------------------
Test1:
Timer1 = 54050
Toggle Porta.1
C = B
   C = C / 2
B = 0
Return